# TruffleRuby Gem Test Pack

## Direct usage

These are the gems needed to run TruffleRuby's `test gems` and `test ecosystem`
commands without having to download anything.
To use them, set `$GEM_HOME` to the `gems` directory.

To add a new gem or update an existing one, `gem install` it with `$GEM_HOME` set:

```bash
# Switch to MRI
cd gems
export GEM_HOME=`pwd`
export GEM_PATH=`pwd`
gem install -E MYGEM -v VERSION
find . -regextype posix-egrep -regex ".*\.(o|so|bc|su)$" -type f -delete
find gems/gems/MYGEM-VERSION/ -name Makefile -delete
rm -r gems/cache
rm -r gems/doc
rm -r gems/extensions

# Remove gems .gitignore
rm **/.gitignore
```

## Creating the archive

A good way to create the .tar.gz is:

```bash
export PACK_VERSION=1
git archive --prefix=truffleruby-gem-test-pack-$PACK_VERSION/ -o truffleruby-gem-test-pack-$PACK_VERSION.tar.gz HEAD
```

## `truffleruby-tool` tool usage

The tool has options to use this repository `truffleruby-tool ci --offline
<gem-name>` (also see `--offline-gem-path` option).

To add gems for ecosystem tests merge their `.truffleruby-tool_bundle/truffleruby/2.3.0`
with `./gems`, e.g.:

    rsync -a rails/activemodel/.truffleruby-tool_bundle/truffleruby/2.3.0/ \
    ../../../../../truffleruby-gem-test-pack/gems/

If the dependencies of the gem have a gem pulled from git, the dir containing
the git repository can be added with:

    git add gems/bundler/gems/qu-d098e2657c92/
    # the last `/` is significant

## `gem-testing` directory

The `gem-testing` directory contains repository clones of gems which are tested in
CI. They are added using `git-subtree` as follows:

    git remote add rails https://github.com/rails/rails.git
    git fetch rails
    git subtree add --prefix=gem-testing/rails --squash rails v4.2.6

`jt test ecosystem` will use the `gem-testing` directory.

## Licenses

See individual gems.
